#include <Arduino.h>
#include <avr/wdt.h>
#include <Wire.h>
#include <OneWire.h>
#include <DallasTemperature.h>

#define ONE_WIRE_BUS 53
//One Wire
OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);  

typedef struct czujka_temp_class_{
    DeviceAddress adressCzujnikTemperatury;
    float aktualnaTemperatura;
} czujka_temp_class;

typedef struct room_temp_class_{
    word podlogaZaworGPIO;
    float temperaturaZadana;
    float histerazaMin;
    float histerazaMax;
    word iloscCzujnikow;
    bool stanOgrzewania;
    czujka_temp_class czujnikTemperatury[];
}room_temp_class;

typedef struct buffor_class_
{
    word pompaGPIO;
    int temperaturaZadana;
    int histerazaMin;
    int histerazaMax;
    bool stanPompy;
    czujka_temp_class czujnikTemperatury;
}buffor_class;


room_temp_class salon = {
11,25,1,1,5,false,
{{{0x28, 0xE7, 0xAF, 0xE5, 0x17, 0x20, 0x06, 0x0A },0}, //Lewy róg
{{0x28, 0xAA, 0xB1, 0xC4, 0x4F, 0x14, 0x01, 0xDF },0}, // pod oknem
{{0x28, 0xC6, 0x56, 0x25, 0x13, 0x21, 0x01, 0x3E },0}, // pod kanapą
{{0x28, 0x23, 0xCC, 0x95, 0xF0, 0x01, 0x3C, 0xC6 },0}, // środek
{{0x28, 0xAA, 0x41, 0xB6, 0x3B, 0x14, 0x01, 0xA7 },0}} // prawy róg
};

room_temp_class jadalnia_wykusz = {
6,25,1,1,2,false,
{{{0x28, 0xCE, 0x6D, 0xED, 0x17, 0x20, 0x06, 0x97 },0},
{{0x28, 0xFE, 0x35, 0x3E, 0x13, 0x21, 0x01, 0x81 },0}}
};

room_temp_class przedpokoj = {
7,25,1,1,2,false,
{{{0x28, 0xAA, 0xE2, 0xCD, 0x4F, 0x14, 0x01, 0x97 },0},
{{0x28, 0xAA, 0x5B, 0xD1, 0x4F, 0x14, 0x01, 0x01 },0}}
};

room_temp_class lazienka_dol = {
13,33,1,1,2,false,
{{{0x28, 0xAA, 0xB0, 0xE4, 0x4F, 0x14, 0x01, 0x62 },0},
{{0x28, 0xAA, 0xF0, 0xD7, 0x4F, 0x14, 0x01, 0x4B },0}}
};

room_temp_class panorama = {
4,25,1,1,1,false,
{{{0x28, 0x20, 0x0A, 0xDC, 0x17, 0x20, 0x06, 0x2A },0}}
};

room_temp_class sypialnia ={
9,24,1,1,1,false,
{{{0x28, 0x62, 0x24, 0x45, 0x13, 0x21, 0x01, 0xC0 },0}}
};

room_temp_class sypialnia_pod_lozkiem ={
5,23,1,1,1,false,
{{{0x28, 0x05, 0x5F, 0x95, 0xF0, 0x01, 0x3C, 0x3B },0}}
};

room_temp_class taras = { // nie kompletne dane brak adresów czujnika
10,0,1,1,0,false,
{{{0x28, 0x05, 0x5F, 0x95, 0xF0, 0x01, 0x3C, 0x3B },0}}
};

room_temp_class lazienka_gora = { // nie kompletne dane brak adresów czujnika
8,0,1,1,0,false,
{{{0x28, 0xAA, 0xB0, 0xE4, 0x4F, 0x14, 0x01, 0x62 },0},
{{0x28, 0xAA, 0xF0, 0xD7, 0x4F, 0x14, 0x01, 0x4B },0}}
};

room_temp_class przybudowka = { // nie kompletne dane brak adresów czujnika
12,0,1,1,0,false,
{{{0x28, 0x05, 0x5F, 0x95, 0xF0, 0x01, 0x3C, 0x3B },0}}
};

buffor_class buffor_gora = { 
0,25,1,0,false,
{{0x28, 0xA4, 0x15, 0x40, 0x13, 0x21, 0x01, 0x25 },0}
};

buffor_class buffor_cuw = {
0,60,1,0,false,
{{0x28, 0x70, 0x10, 0xDE, 0x17, 0x20, 0x06, 0xC2 },0}
};

buffor_class buffor_podlogowka = {
14,60,1,0,false,
{{0x28, 0xCF, 0x03, 0x2B, 0x13, 0x21, 0x01, 0xFA },0}
};

buffor_class buffor_dol = {
0,25,1,0,false,
{{0x28, 0x70, 0x9E, 0x1C, 0x13, 0x21, 0x01, 0x4C },0}
};

const word pompaPodlogaGPIO = 14;
const word pompaMieszaniaBuffora = 0;  // brak danych
const word pompaSzuszarkaGPIO = 17;
const word grzalkaSzuszarkiDol = 15;
const word grzalkaSzuszarkiGora = 16;

const long odczytTemperaturyDelay = 8000;
unsigned long odczytTemperaturyCurrent = 0;

const long printToSerialDelay = 2000;
unsigned long printToSerialCurrent = 0;

bool blokadaPompyPodlogowki = true;
bool automat = true;

void aktywojCzujnik(room_temp_class val);
void odczytTemperatury(room_temp_class &val);
void aktywojCzujnik(buffor_class val);
void odczytTemperatury(buffor_class &val);
bool termostatPomieszczen(room_temp_class &val);