#include <Arduino.h>
#include "main.h"


void aktywojCzujnik(room_temp_class val){
  if (val.iloscCzujnikow != 0){
    for (word i=0;i<val.iloscCzujnikow;i++){
      sensors.setResolution(val.czujnikTemperatury[i].adressCzujnikTemperatury, 12);    
    }
  }
  pinMode(val.podlogaZaworGPIO, OUTPUT);
}

void odczytTemperatury(room_temp_class &val){
  if (val.iloscCzujnikow != 0){
    for (word i=0;i<val.iloscCzujnikow;i++){
      val.czujnikTemperatury[i].aktualnaTemperatura = sensors.getTempC(val.czujnikTemperatury[i].adressCzujnikTemperatury);
    }
  }
}

void aktywojCzujnik(buffor_class val){
  sensors.setResolution(val.czujnikTemperatury.adressCzujnikTemperatury, 12);    
  pinMode(val.pompaGPIO, OUTPUT);
}

void odczytTemperatury(buffor_class &val){
      val.czujnikTemperatury.aktualnaTemperatura = sensors.getTempC(val.czujnikTemperatury.adressCzujnikTemperatury);
}

bool termostatPomieszczen(room_temp_class &val){
  bool ogrzewnie_wlacz = false;
  bool ogrzewnie_wylacz = false;
  if (val.iloscCzujnikow != 0){
    for (word i; i<val.iloscCzujnikow;i++){  
      if (val.czujnikTemperatury[i].aktualnaTemperatura < val.temperaturaZadana - val.histerazaMin){
        ogrzewnie_wlacz=true;
      }  
      if (val.czujnikTemperatury[i].aktualnaTemperatura > val.temperaturaZadana + val.histerazaMax){
        ogrzewnie_wylacz = true;
      }      
    }
    if (ogrzewnie_wlacz){
      digitalWrite(val.podlogaZaworGPIO, true);  
    } else if (ogrzewnie_wylacz){
      digitalWrite(val.podlogaZaworGPIO, false);  
    }
    //if (digitalRead())
    val.stanOgrzewania = digitalRead(val.podlogaZaworGPIO);
    return val.stanOgrzewania;
  }
  return false;
} 


void setup() {

  Serial.begin(115200);
  Wire.begin();
  {
    wdt_enable(WDTO_8S);
  }
  sensors.begin(); //Inicjalizacja czujnikow
  pinMode(ONE_WIRE_BUS, INPUT);
  // aktywacja czujników i GPIO od eletrozaworów  
  aktywojCzujnik(sypialnia);
  aktywojCzujnik(sypialnia_pod_lozkiem);
  aktywojCzujnik(panorama);
  aktywojCzujnik(salon);
  aktywojCzujnik(jadalnia_wykusz);
  aktywojCzujnik(przedpokoj);
  aktywojCzujnik(lazienka_gora);
  aktywojCzujnik(taras);
  aktywojCzujnik(przybudowka);
  aktywojCzujnik(lazienka_dol);
  aktywojCzujnik(buffor_dol);
  aktywojCzujnik(buffor_gora);
  aktywojCzujnik(buffor_cuw);
  aktywojCzujnik(buffor_podlogowka);
  pinMode(pompaPodlogaGPIO, OUTPUT);
  pinMode(grzalkaSzuszarkiDol, OUTPUT);
  pinMode(grzalkaSzuszarkiGora, OUTPUT);
  pinMode(pompaSzuszarkaGPIO, OUTPUT);
  delay(8000);
//  odczytTemperatury.delay(8000);
 // delayCzasPompy.delay(opoznienie);  // wstępna inicjalizacja delay
}

void loop() {
  unsigned long time_start = millis();
  if (time_start >  odczytTemperaturyCurrent + odczytTemperaturyDelay){
    odczytTemperaturyCurrent = millis();
    sensors.requestTemperatures();
    odczytTemperatury(sypialnia);
    odczytTemperatury(sypialnia_pod_lozkiem);
    odczytTemperatury(panorama);
    odczytTemperatury(salon);
    odczytTemperatury(jadalnia_wykusz);
    odczytTemperatury(przedpokoj);
    odczytTemperatury(lazienka_gora);
    odczytTemperatury(taras);
    odczytTemperatury(przybudowka);
    odczytTemperatury(lazienka_dol);
    odczytTemperatury(buffor_dol);
    odczytTemperatury(buffor_gora);
    odczytTemperatury(buffor_cuw);
    odczytTemperatury(buffor_podlogowka);
  
    if (buffor_gora.czujnikTemperatury.aktualnaTemperatura > 95){
      digitalWrite(pompaPodlogaGPIO, true);
      digitalWrite(pompaSzuszarkaGPIO, true);
      digitalWrite(sypialnia.podlogaZaworGPIO, true);
      digitalWrite(sypialnia_pod_lozkiem.podlogaZaworGPIO, true);
      digitalWrite(panorama.podlogaZaworGPIO, true);
      digitalWrite(salon.podlogaZaworGPIO, true);
      digitalWrite(jadalnia_wykusz.podlogaZaworGPIO, true);
      digitalWrite(przedpokoj.podlogaZaworGPIO, true);
      digitalWrite(lazienka_gora.podlogaZaworGPIO, true);
      digitalWrite(taras.podlogaZaworGPIO, true);
      digitalWrite(przybudowka.podlogaZaworGPIO, true);
      digitalWrite(lazienka_dol.podlogaZaworGPIO, true);
      automat = false;
    }

    if (buffor_gora.czujnikTemperatury.aktualnaTemperatura < 90){
      automat = true;
    }

    if (automat){
      if (buffor_podlogowka.czujnikTemperatury.aktualnaTemperatura >= buffor_podlogowka.temperaturaZadana+buffor_podlogowka.histerazaMax){
          blokadaPompyPodlogowki = false;
      };
      if (buffor_podlogowka.czujnikTemperatury.aktualnaTemperatura < buffor_podlogowka.temperaturaZadana-buffor_podlogowka.histerazaMin){
          blokadaPompyPodlogowki = true;
          digitalWrite(buffor_podlogowka.pompaGPIO, false);
      };
  

      if (!blokadaPompyPodlogowki && automat){
        if (termostatPomieszczen(sypialnia)||termostatPomieszczen(sypialnia_pod_lozkiem)||termostatPomieszczen(panorama)||termostatPomieszczen(salon)||termostatPomieszczen(jadalnia_wykusz)||
            termostatPomieszczen(przedpokoj)||termostatPomieszczen(lazienka_gora)||termostatPomieszczen(taras)||termostatPomieszczen(przybudowka)||termostatPomieszczen(lazienka_dol)){
          digitalWrite(pompaPodlogaGPIO, true);
        } 
        else{
          digitalWrite(pompaPodlogaGPIO, false);
        }
      } 
  
      if (buffor_gora.czujnikTemperatury.aktualnaTemperatura > buffor_dol.czujnikTemperatury.aktualnaTemperatura+10 or buffor_dol.czujnikTemperatury.aktualnaTemperatura > buffor_gora.czujnikTemperatury.aktualnaTemperatura+10){
        // załącz pompę mieszającą buffor
      }
    }

    Serial.println("");
    Serial.print("Bufor Góra: ");
    Serial.print(buffor_gora.czujnikTemperatury.aktualnaTemperatura);
    Serial.println(" °C");
    Serial.print("Bufor 3/4: ");
    Serial.print(buffor_cuw.czujnikTemperatury.aktualnaTemperatura);
    Serial.println(" °C");
    Serial.print("Bufor 2/4: ");
    Serial.print(buffor_podlogowka.czujnikTemperatury.aktualnaTemperatura);
    Serial.println(" °C");
    Serial.print("Bufor Dół: ");
    Serial.print(buffor_dol.czujnikTemperatury.aktualnaTemperatura);
    Serial.println(" °C");
    if (!blokadaPompyPodlogowki) {
      Serial.println("Temperatura minimalna Bufora osiągnieta ");
      Serial.println("");
    }
    else {
      Serial.println("Temperatura minimalna Bufora nie osiągnieta ");
      Serial.println("");
    }
    if (digitalRead(buffor_podlogowka.pompaGPIO)) {
      Serial.println("Pompa aktywna");
      Serial.println("");
    }
    Serial.println("");
    Serial.print("Wykusz: ");
    Serial.print(jadalnia_wykusz.czujnikTemperatury[0].aktualnaTemperatura);
    Serial.println(" °C");
    Serial.print("Jadalnia: ");
    Serial.print(jadalnia_wykusz.czujnikTemperatury[1].aktualnaTemperatura);
    Serial.println(" °C");
    if (jadalnia_wykusz.stanOgrzewania) {
      Serial.println("Wykusz i Jadalnia są ogrzewane");
      Serial.println("");
    }
    Serial.println("");
    Serial.print("Salon róg prawy: ");
    Serial.print(salon.czujnikTemperatury[4].aktualnaTemperatura);
    Serial.println(" °C");
    Serial.print("Salon róg lewy: ");
    Serial.print(salon.czujnikTemperatury[0].aktualnaTemperatura);
    Serial.println(" °C");
    Serial.print("Salon środek: ");
    Serial.print(salon.czujnikTemperatury[3].aktualnaTemperatura);
    Serial.println(" °C");
    Serial.print("Salon pod oknem: ");
    Serial.print(salon.czujnikTemperatury[1].aktualnaTemperatura );
    Serial.println(" °C");
    Serial.print("Salon przed kanapą: ");
    Serial.print(salon.czujnikTemperatury[2].aktualnaTemperatura );
    Serial.println(" °C");
    if (salon.stanOgrzewania) {
      Serial.print("Salon jest ogrzewany");
    }
    Serial.println("");
    Serial.println("");
    Serial.print("Przedpokój przy drzwiach: ");
    Serial.print(przedpokoj.czujnikTemperatury[0].aktualnaTemperatura);
    Serial.println(" °C");
    Serial.print("Nad Buforem: ");
    Serial.print(przedpokoj.czujnikTemperatury[1].aktualnaTemperatura );
    Serial.println(" °C");
    if (przedpokoj.stanOgrzewania) {
      Serial.print("Przedpokój jest ogrzewany");
      Serial.println("");
    }
    Serial.println("");
    Serial.print("Łazienka dolna przód: ");
    Serial.print(lazienka_dol.czujnikTemperatury[0].aktualnaTemperatura);
    Serial.println(" °C");
    Serial.print("Łazienka dolna Kabina ");
    Serial.print(lazienka_dol.czujnikTemperatury[1].aktualnaTemperatura);
    Serial.println(" °C");
    if (lazienka_dol.stanOgrzewania) {
      Serial.print("Łazienka dolna jest ogrzewana");
      Serial.println("");
    }
    Serial.println("");
    Serial.print("Panorama: ");
    Serial.print(panorama.czujnikTemperatury[0].aktualnaTemperatura );
    Serial.println(" °C");
    if (panorama.stanOgrzewania) {
      Serial.print("Panorama jest ogrzewana");
      Serial.println("");
    }
    Serial.println("");
    Serial.print("Sypialnia Spanie: ");
    Serial.print(sypialnia_pod_lozkiem.czujnikTemperatury[0].aktualnaTemperatura);
    Serial.println(" °C");
    if (sypialnia_pod_lozkiem.stanOgrzewania) {
      Serial.print("Sypialnia Spanie jest ogrzewana");
      Serial.println("");
    }
    Serial.println("");
    Serial.print("Sypialnia: ");
    Serial.print(sypialnia.czujnikTemperatury[0].aktualnaTemperatura);
    Serial.println(" °C");
    if (sypialnia.stanOgrzewania) {
      Serial.print("Sypialnia jest ogrzewana");
      Serial.println("");
    }
    Serial.println("");
    Serial.print("Łazienka góra: ");
    // Serial.print(lazienka_gora.czujnikTemperatury[0].aktualnaTemperatura);
    Serial.println(" °C");
    if (lazienka_gora.stanOgrzewania) {
      Serial.print("Górna łazienka jest ogrzewana");
      Serial.println("");
    }
    Serial.println("");
    Serial.print("Przybudówka: ");
    // Serial.print(przybudowka.czujnikTemperatury[0].aktualnaTemperatura);
    Serial.println(" °C");
    // Serial.print(przybudowka.czujnikTemperatury[1].aktualnaTemperatura);
    Serial.println(" °C");
    if (przybudowka.stanOgrzewania) {
      Serial.print("Przybudówka jest ogrzewana");
      Serial.println("");
    }
    wdt_reset();
  }
  while (Serial.available()>0) {  //and !trybsetup) {
    String sbuf = Serial.readString();
    if (sbuf == "pomoc"){
      Serial.println("Dostępne pokoje:sypialnia,sypialniaSpanie,panorama,salon,jadalniaWykusz,przedpokoj,lazienkaGora,taras,przybudowka,lazienkaDol,bufforDol,bufforGora.bufforCuw,bufforPodlogowka");
      Serial.println("By ustawić temperature podaj: <nazwapokoju>:<temperatura>");
      Serial.println("Przykład: sypialnia:25");
    }
    if (sbuf.indexOf(':') > 0){
      String opcja = sbuf.substring(0, sbuf.indexOf(':'));
      String wartosc = sbuf.substring(sbuf.indexOf(':')+1, sbuf.length());
      if (opcja == "sypialnia") sypialnia.temperaturaZadana=wartosc.toFloat();
      if (opcja == "sypialniaSpanie") sypialnia_pod_lozkiem.temperaturaZadana=wartosc.toFloat();
      if (opcja == "panorama") panorama.temperaturaZadana=wartosc.toFloat();
      if (opcja == "salon") salon.temperaturaZadana=wartosc.toFloat();
      if (opcja == "jadalniaWykusz") jadalnia_wykusz.temperaturaZadana=wartosc.toFloat();
      if (opcja == "przedpokoj") przedpokoj.temperaturaZadana=wartosc.toFloat();
      if (opcja == "lazienkaGora") lazienka_gora.temperaturaZadana=wartosc.toFloat();
      if (opcja == "taras") taras.temperaturaZadana=wartosc.toFloat();
      if (opcja == "przybudowka") przybudowka.temperaturaZadana=wartosc.toFloat();
      if (opcja == "lazienkaDol") lazienka_dol.temperaturaZadana=wartosc.toFloat();
      if (opcja == "bufforDol") buffor_dol.temperaturaZadana=wartosc.toFloat();
      if (opcja == "bufforGora") buffor_gora.temperaturaZadana=wartosc.toFloat();
      if (opcja == "bufforCuw") buffor_cuw.temperaturaZadana=wartosc.toFloat();
      if (opcja == "bufforPodlogowka") buffor_podlogowka.temperaturaZadana=wartosc.toFloat();
    }
  }
}